using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace dreamex
{
    class Program
    {
        static void Main(string[] args)
        {
            const string pakPath = @"c:\program files\funcom\dreamfall\bin\res\";
            const string idxPath = pakPath + "directory.txt";

            Console.WriteLine("\ndreamfall pak-extractor by pinkunozou (vertigo80@gmx.net)\n");
            
            // Indexing
            Console.WriteLine("\nINDEX-STEP\n");
            if (!File.Exists(idxPath))
            {
                Indexer idx = new Indexer();
                idx.run(pakPath);
                idx.writeIndex(idxPath);
                Console.WriteLine("\n{0} files indexed", idx.numFiles);
            }
            else
                Console.WriteLine("indexfile directory.txt found");

            // load hashtables
            PakXtract xtractor = new PakXtract(pakPath);
            Console.WriteLine("\nEXTRACT-STEP\n");
            
            xtractor.extractFiles(idxPath);
            xtractor.log.Close();

            Console.WriteLine("------------------------------------------");
            Console.WriteLine("{0} unnamed files present", xtractor.countTotal);
            Console.WriteLine("{0} filenames found by indexing", xtractor.countFound);
            Console.WriteLine("{0} filenames found by hashsearch", xtractor.countGuessed);
            Console.WriteLine("{0} files extracted in total", xtractor.countGuessed + xtractor.countFound);
            Console.WriteLine("------------------------------------------");
            Console.WriteLine("{0} indexed files not found", xtractor.countNotFound);
            Console.WriteLine("{0} files double-referenced", xtractor.countDoubleUsed);
            Console.WriteLine("------------------------------------------");            
            Console.ReadKey();
            
        }
    }
}
